package tda548;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Main extends JFrame {

    private class MainPanel extends JPanel implements MouseListener {

        private DrawProg drawProg;

        public MainPanel(DrawProg drawProg) {
            this.drawProg = drawProg;
            this.addMouseListener(this);
        }

        public void paintComponent(Graphics g) {
            super.paintComponent(g);
            g.setColor(Color.WHITE);
            g.fillRect(0,0,this.getWidth(),this.getHeight());
            g.setColor(Color.BLACK);
            drawProg.draw(g);
        }

        public void mousePressed(MouseEvent e) {
            drawProg.mousePressed(e.getX(),e.getY());
            repaint();
        }
        public void mouseReleased(MouseEvent e) {
            drawProg.mouseReleased(e.getX(),e.getY());
            repaint();
        }
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}

    }

    public Main() {
        DrawProg drawProg = new DrawProg();
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setSize(600,450); setLocation(150,150);
        JPanel main = new JPanel(new BorderLayout());
        MainPanel panel = new MainPanel(drawProg);
        main.add(panel,BorderLayout.CENTER);
        JPanel bpanel = new JPanel(new FlowLayout());
        ButtonGroup buttons = new ButtonGroup();
        JRadioButton b1 = new JRadioButton("Line",true);
        JRadioButton b2 = new JRadioButton("Rectangle",false);
        JRadioButton b3 = new JRadioButton("Oval",false);
        JButton b4 = new JButton("Undo");
        buttons.add(b1);
        buttons.add(b2);
        buttons.add(b3);
        b1.addActionListener(e ->
        { drawProg.setMode(b1.getText()); panel.repaint(); });
        b2.addActionListener(e ->
        { drawProg.setMode(b2.getText()); panel.repaint(); });
        b3.addActionListener(e ->
        { drawProg.setMode(b3.getText()); panel.repaint(); });
        b4.addActionListener(e -> { drawProg.undo(); panel.repaint(); });
        drawProg.setMode(b1.getText());
        bpanel.add(b1);
        bpanel.add(b2);
        bpanel.add(b3);
        bpanel.add(b4);
        main.add(bpanel,BorderLayout.NORTH);
        this.add(main); setVisible(true);
    }

    public static void main(String[] args) {
        Main f = new Main();
    }

}
